<?php
/**
 * @brief		Members Shop Application Class
 * @author		<a href='https://ipsdev.org'>TheJackal</a>
 * @copyright	(c) 2017 TheJackal
 * @package		Invision Community
 * @subpackage	Members Shop
 * @since		26 Nov 2017
 * @version		
 */
 
namespace IPS\membersshop;

/**
 * Members Shop Application Class
 */
class _Application extends \IPS\Application
{
	protected function get__icon()
	{
		return 'shopping-basket';
	}
	
	public function defaultFrontNavigation()
	{
		return array(
			'rootTabs'		=> array(
				array(
					'key'		=> 'shop',
					'children'	=> array(
						array( 'key' => 'myitems' ),
						array( 'key' => 'logs' ),
						array( 'key' => 'statistics' )
					),
				),
			),
			'browseTabs'	=> array(),
			'browseTabsEnd'	=> array(),
			'activityTabs'	=> array()
		);
	}
    
    public function installOther()
	{
		try
		{
			if(!\IPS\Db::i()->checkForColumn('downloads_categories', 'ms_points_upload')) {
				\IPS\Db::i()->addColumn('downloads_categories', array(
				    'name'		=> 'ms_points_upload',
				    'type'		=> 'INT',
				    'length'	=> 20,
				    'allow_null'=> TRUE,
				    'default'	=> NULL,
				    'comment'	=> ''
			));
		    }
		}
		catch( \Exception $ex ){}
		
		try
		{		
			if(!\IPS\Db::i()->checkForColumn('downloads_categories', 'ms_points_downloads')) {
			    \IPS\Db::i()->addColumn('downloads_categories', array(
				    'name'		=> 'ms_points_downloads',
				    'type'		=> 'INT',
				    'length'	=> 20,
				    'allow_null'=> TRUE,
				    'default'	=> NULL,
				    'comment'	=> ''
			));
			}
		}
		catch( \Exception $ex ){}

		try
		{		
			if(!\IPS\Db::i()->checkForColumn('nexus_packages', 'p_shop_points')) {
			    \IPS\Db::i()->addColumn('nexus_packages', array(
				    'name'		=> 'p_shop_points',
				    'type'		=> 'INT',
				    'length'	=> 20,
				    'allow_null'=> TRUE,
				    'default'	=> NULL,
				    'comment'	=> ''
			));
			}
		}	
		catch( \Exception $ex ){}
	}	
}