<?php
/**
 * @brief		Admin CP Member Form
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Members Shop
 * @since		26 Nov 2017
 */

namespace IPS\membersshop\extensions\core\MemberForm;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Admin CP Member Form
 */
class _points
{
	/**
	 * Action Buttons
	 *
	 * @param	\IPS\Member	$member	The Member
	 * @return	array
	 */
	public function actionButtons( $member )
	{
		return array(
			'id'	=> array(
				'title'		=> 'title',
				'icon'		=> 'cog',
				'link'		=> \IPS\Http\Url::internal( "app=membersshop&module=&controller=&do=&id={$member->member_id}" ),
				'class'		=> ''
			)
		);
	}

	/**
	 * Process Form
	 *
	 * @param	\IPS\Helpers\Form		$form	The form
	 * @param	\IPS\Member				$member	Existing Member
	 * @return	void
	 */
	public function process( &$form, $member )
	{
		if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
		{
		    $form->add( new \IPS\Helpers\Form\Number( 'ms_points', $member->shop_points, TRUE ) );
		}
		else
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_points', $member->evox_points, TRUE ) );
		}
	}
	
	/**
	 * Save
	 *
	 * @param	array				$values	Values from form
	 * @param	\IPS\Member			$member	The member
	 * @return	void
	 */
	public function save( $values, &$member )
	{
		if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
		{
		    $member->shop_points = $values['ms_points'];	
		}
		else
		{
			$member->evox_points = $values['ms_points'];
		}
	}
}