//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class membersshop_hook_ipsNexusPackage extends _HOOK_CLASS_
{
	/**
	 * [Node] Add/Edit Form
	 *
	 * @param	\IPS\Helpers\Form	$form	The form
	 * @return	void
	 */
	public function form( &$form )
	{
		try
		{
			try
			{
				parent::form( $form );
				
				try
				{
				    $points = \IPS\Db::i()->select( 'p_shop_points', 'nexus_packages', array( 'p_id=?', $this->id ) )->first();
				}
				catch( \Exception $ex )
			    {
					$points = 0;
				}
				
				$form->addTab( 'ms_members_shop' );
				$form->add( new \IPS\Helpers\Form\Number( 'ms_nexus_shop_points', $points, FALSE, array( 'min' => 0 ), NULL, NULL, NULL, 'ms_nexus_shop_points' ) );
			    
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	/**
	 * [Node] Save Add/Edit Form
	 *
	 * @param	array	$values	Values from the form
	 * @return	void
	 */
	public function saveForm( $values )
	{
		try
		{
			try
			{
				\IPS\Db::i()->update( 'nexus_packages', array( 'p_shop_points' => $values['ms_nexus_shop_points'] ), array( 'p_id=?', $this->id ) );
					
				return parent::saveForm( $values );
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
