<?php


namespace IPS\membersshop\modules\admin\points;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * downloads
 */
class _downloads extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		if ( \IPS\Application::appIsEnabled( 'downloads') )
		{
		    \IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('module__membersshop_points_downloads');	   
       
	        $matrix = new \IPS\Helpers\Form\Matrix;
        
        	$matrix->manageable = FALSE;
	        $matrix->widths = array( 'label' => 30 );
	        $matrix->langPrefix = 'ms_downloads_';
        
	        $matrix->columns = array(
				'label'	=> function( $key, $value, $data )
				{
					return $value;
				}
			);
                
	        $matrix->columns[ 'ms_points_upload' ] = function( $key, $value, $data ) 
			{
				return ( is_null( $value ) ) ? NULL : new \IPS\Helpers\Form\Number( 'topics_'.$key, $value, FALSE, array( 'disabled' => (bool) is_null( $value ) ) );
			};                
			$matrix->columns[ 'ms_points_downloads' ] = function( $key, $value, $data )
			{
				return ( is_null( $value ) ) ? NULL : new \IPS\Helpers\Form\Number( 'replies_'.$key, $value, FALSE, array( 'disabled' => (bool) is_null( $value ) ) );
			};

	        $rows = array();
		
			foreach( \IPS\downloads\Category::roots( NULL ) AS $root )
			{
				self::populatePermissionMatrix( $rows, $root );
			}
		
			$matrix->rows = $rows;

	        if( $values = $matrix->values() )
   		    {
				if ( !empty( $matrix->changedRows ) )
				{
					foreach ( $matrix->changedRows as $key )
					{
					    $update = array( 'ms_points_upload'   => (int) $values[ $key ]['ms_points_upload'],
                                     'ms_points_downloads'   => (int) $values[ $key ]['ms_points_downloads'] );
                                     
						\IPS\Db::i()->update( 'downloads_categories', $update, array( 'cid=?', $key ) );
					}
				}
	        }
        
		    /* Buttons */
			\IPS\Output::i()->sidebar['actions']['add'] = array(
				'primary'	=> true,
				'icon'		=> 'comment-o',
				'title'		=> 'ms_forums',
				'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=forums' ),
				'data'		=> array( )
		    );

            if ( \IPS\Settings::i()->clubs )
			{
				\IPS\Output::i()->sidebar['actions']['clubs'] = array(
					'icon'		=> 'users',
					'title'		=> 'ms_clubs',
					'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=clubs' ),
					'data'		=> array( )
				);	
			}			
		
	        \IPS\Output::i()->output = $matrix;
		}
		else
		{
			\IPS\Output::i()->output = 'Downloads must be installed and enabled';
		}
	}
	
	public static function populatePermissionMatrix( &$rows, $downloads, $level=0 )
	{
		$rows[ $downloads->_id ] = array( '_level' => $level, 'label' => $downloads->_title );
        
        $rows[ $downloads->_id ]['ms_points_upload']   = (int) $downloads->ms_points_upload;
    	$rows[ $downloads->_id ]['ms_points_downloads']   = (int) $downloads->ms_points_downloads;
        
        
        if ( $downloads->hasChildren( NULL ) === TRUE )
		{
			$level++;
			foreach( $downloads->children( NULL ) AS $child )
			{
				self::populatePermissionMatrix( $rows, $child, $level );
			}
			$level--;
		}
	}
}