<?php


namespace IPS\membersshop\modules\admin\points;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * settings
 */
class _settings extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$form = new \IPS\Helpers\Form;
		$form->addTab('ms_points_settings');
		$form->addHeader('ms_what_points');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_sel_what_points',  \IPS\Settings::i()->ms_sel_what_points, TRUE, array( 'options' => array_merge( array( 0 => 'Members Shop', 1 => 'evox_points' ) ) ) ) );
		$form->addHeader('ms_who_can_gain');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_group_gain_forums', ( \IPS\Settings::i()->ms_group_gain_forums == 'all' ) ? 'all' : explode( ',', \IPS\Settings::i()->ms_group_gain_forums ), TRUE, array( 'options' => \IPS\Member\Group::groups(TRUE, FALSE), 'parse' => 'normal', 'multiple' => true, 'unlimited' => 'all', 'unlimitedLang' => 'all_groups' ), NULL, NULL, NULL, 'ms_group_gain_forums' ) );
        $form->addHeader('ms_users_profile');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_profile_header', \IPS\Settings::i()->ms_show_profile_header, FALSE, array() ));
		/*
		$form->addHeader('ms_symbol');
		$form->add( new \IPS\Helpers\Form\Text( 'ms_points_symbol', \IPS\Settings::i()->ms_points_symbol, FALSE, array( ), NULL, NULL, NULL, 'ms_points_symbol' ) );
        */
		$form->addTab('ms_bonus_points');
		$form->addHeader('ms_register_header');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_activate_register', \IPS\Settings::i()->ms_activate_monthly, FALSE, array('togglesOn' => array( 'ms_register_points' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_register_points', \IPS\Settings::i()->ms_register_points, FALSE, array( ), NULL, NULL, NULL, 'ms_register_points' ) );
		$form->addHeader('ms_daily_points_header');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_activate_daily', \IPS\Settings::i()->ms_activate_daily, FALSE, array('togglesOn' => array( 'ms_daily_points' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_daily_points', \IPS\Settings::i()->ms_daily_points, FALSE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_per_day' ), 'ms_daily_points' ) );
        $form->addHeader('ms_weekly_points_header');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_activate_weekly', \IPS\Settings::i()->ms_activate_weekly, FALSE, array('togglesOn' => array( 'ms_weekly_points' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_weekly_points', \IPS\Settings::i()->ms_weekly_points, FALSE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_per_week' ), 'ms_weekly_points' ) );
        $form->addHeader('ms_monthly_points_header');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_activate_monthly', \IPS\Settings::i()->ms_activate_monthly, FALSE, array('togglesOn' => array( 'ms_monthly_points' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_monthly_points', \IPS\Settings::i()->ms_monthly_points, FALSE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_per_month' ), 'ms_monthly_points' ) );
        	
        if ( $values = $form->values() )
        {
	        $form->saveAsSettings();
	        \IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'saved' );
	        return TRUE;
        }
		
		\IPS\Output::i()->sidebar['actions']['remove'] = array(
		    'icon'		=> 'remove',
			'title'		=> 'ms_reset_shop_points',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings&do=resetpoints' ),
			'data'		=> array( 'ipsDialog' => '', 'ipsDialog-title' => \IPS\Member::loggedIn()->language()->addToStack('ms_reset_shop_points') )
		);

		\IPS\Output::i()->sidebar['actions']['add'] = array(
			'primary'	=> true,
			'icon'		=> 'star',
			'title'		=> 'ms_Award_points',
			'link'		=> \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings&do=awardPoints' ),
			'data'		=> array( 'ipsDialog' => '', 'ipsDialog-title' => \IPS\Member::loggedIn()->language()->addToStack('ms_Award_points') )
		);
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_points' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function awardPoints()
	{
		$form = new \IPS\Helpers\Form;
        $form->add( new \IPS\Helpers\Form\Radio( 'ms_award_groups', NULL, FALSE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'ms_award_groups',
		'options' => array(
			0  => 'Member',
			1  => 'Groups',),
		 'toggles' => array(
			0 => array('ms_award_member'),
			1 => array('ms_award_what_group'),
		) ), NULL, NULL, NULL, 'ms_award_groups'));
		
		$form->add( new \IPS\Helpers\Form\Member( 'ms_award_member', NULL, FALSE, array( 'max' => 1 ), NULL, NULL, NULL, 'ms_award_member' ) );
		$form->add( new \IPS\Helpers\Form\Select( 'ms_award_what_group', NULL, FALSE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'ms_award_what_group' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_award_amount', NULL, FALSE, array( 'min' => 1 ), NULL, NULL, NULL, 'ms_award_amount' ) );
				
		if ( $values = $form->values() )
        {
			if ( $values['ms_award_member']  )
			{
				if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
				{
				    \IPS\Db::i()->update( 'core_members', array( 'shop_points' => $values['ms_award_member']->shop_points + $values['ms_award_amount'] ), array ( 'member_id=?', $values['ms_award_member']->member_id ) );
				}
				else
				{
				    \IPS\Db::i()->update( 'core_members', array( 'evox_points' => $values['ms_award_member']->evox_points + $values['ms_award_amount'] ), array ( 'member_id=?', $values['ms_award_member']->member_id ) );
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'ms_points_awarded' );
	        }
			
			if ( $values['ms_award_groups'] = 1  )
			{
			    foreach( \IPS\Db::i()->select( '*', 'core_members', array( 'member_group_id=?', $values['ms_award_what_group'] ) ) as $member )
				{
					try
					{
						if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
						{
							\IPS\Db::i()->update( 'core_members', array( 'shop_points' => $member['shop_points'] + $values['ms_award_amount'] ), array ( 'member_group_id=?', $member['member_group_id'] ) );
					    }
						else
						{
							\IPS\Db::i()->update( 'core_members', array( 'evox_points' => $member['evox_points'] + $values['ms_award_amount'] ), array ( 'member_group_id=?', $member['member_group_id'] ) );
					    }
						\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'ms_points_awarded' );
					}
					catch( \Exception $e ){}
				}
			}
			
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Nothing Has Been Done' );
        }		
		
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_Award_points' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function resetpoints()
	{
		$form = new \IPS\Helpers\Form;
        $form->addHeader('ms_reset_all_points');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_mass_reset', 'no', FALSE, array( 'options' => array_merge( array( 'no' => 'No', 'yes' => 'Yes' ) ) ) ) );
		$form->addHeader('ms_reset_member_groups');
		$form->add( new \IPS\Helpers\Form\Member( 'ms_reset_member', NULL, FALSE, array( 'max' => 1 ), NULL, NULL, NULL, 'ms_reset_member' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_select_reset_groups', \IPS\Settings::i()->ms_select_reset_groups, FALSE, array('togglesOn' => array( 'ms_reset_groups' ), 'togglesOff' => array( 'ms_reset_member' ) ) ) );
		$form->add( new \IPS\Helpers\Form\Select( 'ms_reset_groups', \IPS\Settings::i()->ms_reset_groups, FALSE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'ms_reset_groups' ) );
		
		
		if ( $values = $form->values() )
        {
	        $form->saveAsSettings();
			
			if ( $values['ms_mass_reset'] == 'yes' )
			{
				if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
				{
			        \IPS\Db::i()->update( 'core_members', array( 'shop_points' => 0 ) );
			    }
				else
				{
					\IPS\Db::i()->update( 'core_members', array( 'evox_points' => 0 ) );
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Reset' );
	        }
			
			if ( $values['ms_reset_member']  )
			{
				$member_id = $values['ms_reset_member']->member_id;
				if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
				{
				    \IPS\Db::i()->update( 'core_members', array( 'shop_points' => 0 ), array ( 'member_id=?', $member_id ) );
				}
				else
				{
					\IPS\Db::i()->update( 'core_members', array( 'evox_points' => 0 ), array ( 'member_id=?', $member_id ) );
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Reset' );
	        }
			
			if ( $values['ms_select_reset_groups'] == TRUE  )
			{
				$group_id = $values['ms_reset_groups'];
				if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
				{
				    \IPS\Db::i()->update( 'core_members', array( 'shop_points' => 0 ), array ( 'member_group_id=?', $group_id ) );
				}
				else
				{
					\IPS\Db::i()->update( 'core_members', array( 'evox_points' => 0 ), array ( 'member_group_id=?', $group_id ) );
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Reset' );
	        }
			
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=points&controller=settings' ), 'Nothing has been done' );
	        
		}

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_reset_points' );
		\IPS\Output::i()->output = $form;
	}
}