<?php


namespace IPS\membersshop\modules\admin\shop;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * items
 */
class _items extends \IPS\Node\Controller
{
	/**
     * Node Class
     */
    protected $nodeClass = '\IPS\membersshop\Categories';
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
	}
	
	protected function doCustom()
	{
		$id  = intval( \IPS\Request::i()->item_id );
		$item = \IPS\membersshop\Items::load( $id );
		$form = new \IPS\Helpers\Form( 'membersshop', 'ms_send' );
		$form->add(new \IPS\Helpers\Form\Member('ms_give_to', NULL, TRUE, array( ) ));
		$form->add( new \IPS\Helpers\Form\Text( 'ms_dName', $item->name, TRUE, array( 'placeholder' => '' ), NULL, NULL, NULL, 'ms_dName' ) );
		$form->add( new \IPS\Helpers\Form\Text( 'ms_dDescription', $item->desc, TRUE, array( ), NULL, NULL, NULL, 'ms_dDescription' ) );
        $form->add( new \IPS\Helpers\Form\YesNo( 'ms_dTakePrice', NULL, TRUE, array( 'togglesOff' => array( 'ms_dPrice' ) ), NULL, NULL, NULL, 'ms_dTakePrice' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'ms_dPrice', $item->price, TRUE, array( ), NULL, NULL, NULL, 'ms_dPrice' ) );
		if ( $item->id == 1 or $item->id == 2 or $item->id == 3 or $item->id == 5 or $item->id == 16 or $item->id == 17)
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_dMinRand', $item->minRand, TRUE, array( ), NULL, NULL, NULL, 'ms_dMinRand' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_dMaxRand', $item->maxRand, TRUE, array( ), NULL, NULL, NULL, 'ms_dMaxRand' ) );
		}
		
		if ( $item->id == 10 )
		{
			$form->add( new \IPS\Helpers\Form\YesNo( 'ms_enable_increase', $item->extra_field, TRUE, array( 'togglesOn' => array( 'ms_increase_amount') ), NULL, NULL, NULL, 'ms_enable_increase' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_increase_amount', $item->maxRand, FALSE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_points' ), 'ms_increase_amount' ) );
		}
		
		if ( $item->id == 11 )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_pin_time_days', $item->extra_field, TRUE, array( 'max' => 31, 'min' => 1 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_pin_time_days' ) );
		}
		
		if ( $item->id == 12 )
		{
			$form->add( new \IPS\Helpers\Form\Number( 'ms_feature_time_days', $item->extra_field, TRUE, array( 'max' => 31, 'min' => 1 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_feature_time_days' ) );
		}
		
		if ( $item->id == 13 or $item->id == 14 or $item->id == 15 )
		{
			$form->add( new \IPS\Helpers\Form\Select( 'ms_reward_user_group', $item->minRand, TRUE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ) ) );
	        $form->add( new \IPS\Helpers\Form\Select( 'ms_select_reward_dmy', $item->maxRand, TRUE, array( 
			'options' => array(
				0  => 'Days',
				1  => 'Months',
				2  => 'Years'),
			 'toggles' => array(
				0 => array( 'ms_upgrade_time_days' ),
				1 => array( 'ms_upgrade_time_months' ),
				2 => array( 'ms_upgrade_time_years' ),
			) ), NULL, NULL, NULL, 'ms_select_reward_dmy'));	
    		$form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_days', $item->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_upgrade_time_days' ) );
		    $form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_months', $item->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_months' ), 'ms_upgrade_time_months' ) );
		    $form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_years', $item->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_years' ), 'ms_upgrade_time_years' ) );
		}
		
        if ( $values = $form->values() )
        {
			$purchase = new \IPS\membersshop\Purchases;
			$purchase->item_id = $item->id;
			$purchase->member_id = $values['ms_give_to']->member_id;
			$purchase->name = $values['ms_dName'];
			$purchase->description = $values['ms_dDescription'];
			$purchase->price = $values['ms_dPrice'];
			$purchase->time_date = time();
			$purchase->icon = $item->icon;
			$purchase->redeemed = 0;
			
			/* Save random items values */
			if ( $item->id == 1 or $item->id == 2 or $item->id == 3 or $item->id == 5 or $item->id == 16 or $item->id == 17 )
			{
				$purchase->minRand = $values['ms_dMinRand'];
				$purchase->maxRand = $values['ms_dMaxRand'];
			}
			
			/* Save rpsls increase values */
			if ( $item->id == 10 )
			{
				$purchase->extra_field = $values['ms_enable_increase'];
				$purchase->maxRand = $values['ms_increase_amount'];
			}
			
			/* Save pinned values */
			if ( $item->id == 11 )
			{
				$purchase->extra_field = $values['ms_pin_time_days'];
			}
			
			/* Save featured values */
			if ( $item->id == 12 )
			{
				$purchase->extra_field = $values['ms_feature_time_days'];
			}
			
			/* Save member upgrade values */
			if ( $item->id == 13 or $item->id == 14 or $item->id == 15 )
			{
				if ( $values['ms_select_reward_dmy'] == 0 )
				{
					$purchase->extra_field = $values['ms_upgrade_time_days'];
					$purchase->minRand = $values['ms_reward_user_group'];
					$purchase->maxRand = $values['ms_select_reward_dmy'];
				}
				elseif ( $values['ms_select_reward_dmy'] == 1 )
				{
					$purchase->extra_field = $values['ms_upgrade_time_months'];
					$purchase->minRand = $values['ms_reward_user_group'];
					$purchase->maxRand = $values['ms_select_reward_dmy'];
				}
				elseif ( $values['ms_select_reward_dmy'] == 2 ) 
				{
					$purchase->extra_field = $values['ms_upgrade_time_years'];
					$purchase->minRand = $values['ms_reward_user_group'];
					$purchase->maxRand = $values['ms_select_reward_dmy'];
				}
			}
			
			$purchase->save();
			
			if ( !$values['ms_dTakePrice'] )
			{
				$ItemPrice = $values['ms_dPrice'];
				if ( \IPS\Settings::i()->ms_sel_what_points == 0 )
				{
					$memberPoints = $values['ms_give_to']->shop_points;
					if ( $ItemPrice > $memberPoints )
					{
						$values['ms_give_to']->shop_points = 0;
					}
					else
					{
						$values['ms_give_to']->shop_points = $values['ms_give_to']->shop_points - $ItemPrice;
					}
				}
				else
				{
					$memberPoints = $values['ms_give_to']->evox_points;
					if ( $ItemPrice > $memberPoints )
					{
						$values['ms_give_to']->evox_points = 0;
					}
					else
					{
						$values['ms_give_to']->evox_points = $values['ms_give_to']->evox_points - $ItemPrice;
					}
				}
				$values['ms_give_to']->save();
			}
			
			$member = \IPS\Member::loggedIn();
			$received = new \IPS\membersshop\Received;
			$received->item_id = $item->id;
			$received->sender_id = $member->member_id;
			$received->receiver_id = $values['ms_give_to']->member_id;
			$received->time_date = time();
			$received->save();
			
			$items = \IPS\membersshop\Received::load( $received->id );
			
			$memberssssss = \IPS\Member::load( $values['ms_give_to']->member_id );
			$notification = new \IPS\Notification( \IPS\Application::load( 'membersshop' ), 'received_item', $items, array ( $items ) );
			$notification->recipients->attach( $memberssssss );
			$notification->send();
			
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items' ), 'Sent' );
        }

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'ms_custom_purchase' );
		\IPS\Output::i()->output = $form;
	}
	
	protected function purchasers()
	{
		$id  = intval( \IPS\Request::i()->id );
		$table = new \IPS\Helpers\Table\Db( 'membersshop_purchases', \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items&do=purchasers&id=' . $id ) );
		$table->tableTemplate = array( \IPS\Theme::i()->getTemplate( 'stats' ), 'logTable' );
		$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate( 'stats' ), 'logRows' );
		$table->sortBy = 'time_date';
		$table->limit = 10;
        $table->where[] = array( 'item_id=?', $id );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'stats' )->log( (string) $table );
	}
}