<?php


namespace IPS\membersshop\modules\admin\shop;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * settings
 */
class _settings extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		
		parent::execute();
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		$form = new \IPS\Helpers\Form;
	    $form->addHeader('ms_cost_to_send');
		/*
		$form->add( new \IPS\Helpers\Form\Select( 'ms_group_send_items', ( \IPS\Settings::i()->ms_group_send_items == 'all' ) ? 'all' : explode( ',', \IPS\Settings::i()->ms_group_send_items ), TRUE, array( 'options' => \IPS\Member\Group::groups(TRUE, FALSE), 'parse' => 'normal', 'multiple' => true, 'unlimited' => 'all', 'unlimitedLang' => 'all_groups' ), NULL, NULL, NULL, 'ms_group_send_items' ) );
        */
		$form->add( new \IPS\Helpers\Form\Number( 'ms_charge_to_send', \IPS\Settings::i()->ms_charge_to_send, FALSE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_percent_to_send'), 'ms_charge_to_send' ) );
        
		$form->addHeader('ms_show_stock_levels');
		/*
		$form->add( new \IPS\Helpers\Form\Number( 'ms_show_stock_when', \IPS\Settings::i()->ms_show_stock_when, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_in_stock_setting'), 'ms_show_stock_when' ) );
        */
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_show_stock_level', \IPS\Settings::i()->ms_show_stock_level, TRUE, array( ), NULL, NULL, NULL, 'ms_show_stock_level' ) );
        
		$form->addHeader('ms_shop_view');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_shop_view_set', \IPS\Settings::i()->ms_shop_view_set, TRUE, array( 'options' => array( 0 => 'Table View', 1 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_shop_view_set') );
		$form->add( new \IPS\Helpers\Form\Select( 'ms_myitems_view_set', \IPS\Settings::i()->ms_myitems_view_set, TRUE, array( 'options' => array( 0 => 'Table View', 1 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_myitems_view_set') );
		$form->add( new \IPS\Helpers\Form\Select( 'ms_logs_view_set', \IPS\Settings::i()->ms_logs_view_set, TRUE, array( 'options' => array( 0 => 'Table View', 1 => 'Grid View' ), 'multiple' => FALSE ) , NULL, NULL, NULL, 'ms_logs_view_set') );
		$form->addHeader('ms_confirm_header');
		$form->add( new \IPS\Helpers\Form\YesNo( 'ms_confirm_buy', \IPS\Settings::i()->ms_confirm_buy, TRUE, array( ), NULL, NULL, NULL, 'ms_confirm_buy' ) );
        
		$form->addHeader('ms_side_bar_cat');
		$form->add( new \IPS\Helpers\Form\Select( 'ms_show_sidebar_cat',  \IPS\Settings::i()->ms_show_sidebar_cat, TRUE, array( 'options' => array( 0 => 'Category Sidebar', 1 => 'Filter Box' ) ) ) );
				
		$form->addHeader('ms_table_limits');
		$form->add( new \IPS\Helpers\Form\Number( 'ms_shop_table_limit', \IPS\Settings::i()->ms_shop_table_limit, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_per_page'), 'ms_shop_table_limit' ) );
        $form->add( new \IPS\Helpers\Form\Number( 'ms_myitems_table_limit', \IPS\Settings::i()->ms_myitems_table_limit, TRUE, array( ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_per_page'), 'ms_myitems_table_limit' ) );
        
		if ( $values = $form->values() )
        {
	        $form->saveAsSettings();
		    \IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=settings' ), 'saved' );
	        return TRUE;
        }

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack( 'Settings' );
		\IPS\Output::i()->output = $form;
	}
}