<?php


namespace IPS\membersshop\modules\front\logs;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * logs
 */
class _logs extends \IPS\Dispatcher\Controller
{
	/**
	 * Execute
	 *
	 * @return	void
	 */
	public function execute()
	{
		parent::execute();
		if ( !\IPS\Request::i()->isAjax() AND !\IPS\Settings::i()->IPSDev_Copyright_Remover )
		{
		    $output = "<div style='clear:both;text-align:center;position:absolute;bottom:5px;width:95%;z-index:99999;'><a href='https://www.ipsdev.org/' target='_blank' class='ipsType_light ipsType_smaller'>Members Shop By IPSDev</a></div>";
		    \IPS\Output::i()->output .= $output;  
		}
	}

	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		/* Build Table */
		$table = new \IPS\Helpers\Table\Db( 'membersshop_rewards', \IPS\Http\Url::internal( 'app=membersshop&module=logs&controller=logs' ) );
		$table->include = array( 'item_id', 'member_id', 'time_date', 'reward', 'stolen_from', 'name', 'description', 'id' );
		if ( \IPS\Settings::i()->ms_logs_view_set == 0 )
		{
			$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate('logs', 'membersshop'), 'rows' );
		}
		else
		{
			$table->rowsTemplate = array( \IPS\Theme::i()->getTemplate('logs', 'membersshop'), 'rowsGrid' );
		}
		$table->joins = array();
		$table->langPrefix = 'ms__';
		$table->limit = 12;
		$table->title = 'ms_RewardsNlogs';		
		
		$table->sortBy = $table->sortBy ?: 'time_date';
		
		/* Display */
		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('ms_RewardsNlogs');
		\IPS\Output::i()->breadcrumb[] = array( NULL, \IPS\Member::loggedIn()->language()->addToStack('ms_logs') );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate('logs', 'membersshop')->template( (string) $table );
	}
	
	protected function rewardLog()
	{
		$id  = intval( \IPS\Request::i()->id );
		$rewardLog = \IPS\membersshop\Rewards::load( $id );
		$reward = sprintf( \IPS\Member::loggedIn()->language()->get( 'ms_log_posts' ), $rewardLog->reward, $rewardLog->name  );
		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'logs', 'membersshop' )->rewardLog( $reward );
	}
	// Create new methods with the same name as the 'do' parameter which should execute it
}