<?php

namespace IPS\membersshop;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Categories extends \IPS\Node\Model
{
    protected function get__title()
    {
       return $this->name;
    }
	
    protected static $multitons;
    public static $databaseTable = 'membersshop_item_categories';
    public static $nodeTitle = 'ms_members_shop';
    public static $subnodeClass = 'IPS\membersshop\Items';
	public static $titleLangPrefix = '';
	public static $descriptionLangSuffix = '_desc';
	public static $databaseColumnOrder = 'position';
	public static $seoTitleColumn = 'name';
	protected static $databaseIdFields = [ 'id', 'name' ];
	
	public function form( &$form )
    {		
        $form = new \IPS\Helpers\Form;
		$form->add( new \IPS\Helpers\Form\Text( 'ms_CatTitle', $this->name, TRUE, array( ) ) );
        
        if ( $values = $form->values(TRUE) )
	    {
			if ( \IPS\Request::i()->id == TRUE )
			{
				$id  = intval( \IPS\Request::i()->id );
				$cat = \IPS\membersshop\Categories::load( $id );
			}
			else
			{
				$cat = new \IPS\membersshop\Categories;
			}
			
			$cat->name = $values['ms_CatTitle'];
			$cat->save();
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items' ), 'saved' );
		}
		
	}
	
	public function canDelete()
	{
		if ( $this->id == 1 )
		{
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	
	public function canCopy()
	{
		return FALSE;
	}
	
	public function canAdd()
	{
		return TRUE;
	}
	
	public static function names()
	{
		try
		{
			$sort = 'position ASC';
		    $db = \IPS\Db::i()->select( 'name', 'membersshop_item_categories', array( 'id IS NOT NULL' ), $sort );
	    }
		catch( \UnderflowException $ex )
		{
			$db = NULL;
		}
		return $db;
	}	
}