<?php

namespace IPS\membersshop;

if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
    header( ( isset( $_SERVER[ 'SERVER_PROTOCOL' ] ) ? $_SERVER[ 'SERVER_PROTOCOL' ] :
            'HTTP/1.0' ) . ' 403 Forbidden' );
    exit;
}

class _Items extends \IPS\Node\Model implements \IPS\Node\Permissions
{
    protected static $multitons;
    public static $databaseTable = 'membersshop_items';
    public static $databasePrefix = '';
	public static $databaseColumnOrder = 'position';
	public static $parentNodeColumnId = 'cat_id';
    protected static $databaseIdFields = [ 'id', 'member_id', 'position', 'cat_id' ];
    public static $permApp = 'membersshop';
	public static $permType = 'items';
	public static $permissionLangPrefix = 'ms_';
	public static $permissionMap = array(
		'view' 				=> 'view',
		'buy'				=> 2,
		'send'				=> 3
	);
	
	protected function get__title()
    {
       return $this->name;
    }
	
	protected function get__enabled()
    {
        return $this->open;
    }
    
    protected function set__enabled( $enabled )
    {
        $this->open = $enabled;
    }
	
	public function get__icon()
	{
		$icon =  mb_substr($this->icon, 3);
		return $icon;
	}

	public function canAdd()
	{
		return FALSE;
	}
	
	public static function canAddRoot()
	{
		return TRUE;
	}
	
	public function get__description()
	{
		return FALSE;
	}
	
	public function canDelete()
	{
		return TRUE;
	}
	
	public function canCopy()
    {
        return TRUE;
    }
    
    public function delete()
    {
		/*
		try
		{
			\IPS\Db::i()->delete( 'core_permission_index', array( 'perm_type_id=?', $this->id ) );
		}
		catch( \Exception $e ){}
		*/
	    parent::delete();
    }
	
	public function form( &$form )
    {
		if ( \IPS\Request::i()->parent == TRUE )
		{
			$options = array(
			  9    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_signature' ),
			  20   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_amonymous' ),
			  6    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_member_title' ),
			  4    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_username' ),
			  100  => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_custom' ),
			  12   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_feature_file' ),
			  8    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_forum_password' ),
			  21   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_guess_number' ),
			  5    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_mystery_points_box' ),
			  11   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_pin_topic' ),
			  1    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_post_count' ),
			  2    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_rep_count' ),
			  18   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_trophy' ),
			  7    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_warning_points' ),
			  10   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_rpsls' ),
			  3    => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_steal_rep' ),
			  19   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_avatar' ),
			  13   => \IPS\Member::loggedIn()->language()->addToStack( 'ms_item_upgrade_usergroup' ),
			);
				
			$form = new \IPS\Helpers\Form( 'ms', 'Add' );
		    $form->add( new \IPS\Helpers\Form\Select( 'ms_add_item_to_shop', NULL, TRUE, array( 'options' => $options ), NULL, NULL, NULL, 'ms_add_item_to_shop' ) );
			if ( $values = $form->values() )
	        {
				if ( $values['ms_add_item_to_shop'] == 12 AND !\IPS\Application::appIsEnabled( 'downloads') )
				{
					\IPS\Output::i()->error( 'ms_downloads_error', 'MEMBERSHOP/1', 403, '' );
				}
				if (  $values['ms_add_item_to_shop'] == 18 AND !\IPS\Application::appIsEnabled( 'trophies') )
				{
					\IPS\Output::i()->error( 'ms_trophies_error', 'MEMBERSHOP/1', 403, '' );
				}
				if ( $values['ms_add_item_to_shop'] == 1 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_post_count' );
					$addItem->price = 1000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Add a random amount between 10 and 100 to your post count';
					$addItem->icon = 'fa-comment-o';
					$addItem->minRand = 10;
					$addItem->maxRand = 100;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 1;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 2 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_rep_count' );
					$addItem->price = 1000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Add a random amount between 10 and 100 to your profiles reputation';
					$addItem->icon = 'fa-heart';
					$addItem->minRand = 10;
					$addItem->maxRand = 100;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 2;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 3 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_steal_rep' );
					$addItem->price = 2500;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Steal between 1 and 100 reputaion points from your chosen member';
					$addItem->icon = 'fa-user-secret';
					$addItem->minRand = 1;
					$addItem->maxRand = 100;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 3;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 4 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_username' );
					$addItem->price = 2500;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Change your username at any given time';
					$addItem->icon = 'fa-user-o';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 4;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 5 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_mystery_points_box' );
					$addItem->price = 1250;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Open a mystery box and win between 10 and 2500 points';
					$addItem->icon = 'fa-gift';
					$addItem->minRand = 10;
					$addItem->maxRand = 2500;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 5;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 6 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_member_title' );
					$addItem->price = 1750;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Change your member title at any given time';
					$addItem->icon = 'fa-address-card';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 6;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 7 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_warning_points' );
					$addItem->price = 25000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'This will reset your warning points back to zero';
					$addItem->icon = 'fa-exclamation-triangle';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 7;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 8 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_forum_password' );
					$addItem->price = 30000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Gain access to locked forums by getting their passwords';
					$addItem->icon = 'fa-hashtag';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 8;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 9 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_signature' );
					$addItem->price = 5000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'This will allow you to add a signature';
					$addItem->icon = 'fa-edit';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 9;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 10 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_rpsls' );
					$addItem->price = 500;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Play the famous rock paper scissors lizard spock game';
					$addItem->icon = 'fa-hand-spock-o';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 10;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 11 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_pin_topic' );
					$addItem->price = 1000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Pin any topic for 7 days';
					$addItem->icon = 'fa-map-pin';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->extra_field = 7;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 11;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 12 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_feature_file' );
					$addItem->price = 1000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Feature a uploaded file for 7 days';
					$addItem->icon = 'fa-download';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->extra_field = 7;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 12;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 13 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_upgrade_usergroup' );
					$addItem->price = 20000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Upgrade your usergroup to XXX for 31 days';
					$addItem->icon = 'fa-user';
					$addItem->minRand = 3;
					$addItem->maxRand = 0;
					$addItem->extra_field = 31;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 13;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 18 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_trophy' );
					$addItem->price = 10000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Try your luck to win a random trophy';
					$addItem->icon = 'fa-trophy';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 18;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 19 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_avatar' );
					$addItem->price = 1250;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Upload a avatar to your profile';
					$addItem->icon = 'fa-image';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 19;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 20 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_amonymous' );
					$addItem->price = 2500;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Browse the site while appearing offline';
					$addItem->icon = 'fa-user-secret';
					$addItem->minRand = NULL;
					$addItem->maxRand = NULL;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 20;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 21 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_guess_number' );
					$addItem->price = 500;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Win 5x times your stake if you guess the number between 1 and 500';
					$addItem->icon = 'fa-question-circle';
					$addItem->minRand = 5;
					$addItem->maxRand = 500;
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 21;
					$addItem->save();
				}
				if ( $values['ms_add_item_to_shop'] == 100 )
				{
					$addItem = new \IPS\membersshop\Items;
					$addItem->name = \IPS\Member::loggedIn()->language()->get( 'ms_item_custom' );
					$addItem->price = 100000;
					$addItem->open = 1;
					$addItem->purchases = 0;
					$addItem->desc = 'Enter your description here';
					$addItem->icon = 'fa-bell';
					$addItem->instock = -1;
					$addItem->cat_id = \IPS\Request::i()->parent;
					$addItem->item_id = 100;
					$addItem->save();
				}
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items&subnode=1&do=form&id='.$addItem->id.'' ), 'saved' );
			}
		}
		else
		{
			$form = new \IPS\Helpers\Form;
			$form->add( new \IPS\Helpers\Form\Text( 'ms_dName', $this->name, TRUE, array( 'placeholder' => '' ), NULL, NULL, NULL, 'ms_dName' ) );
			$form->add( new \IPS\Helpers\Form\Text( 'ms_dDescription', $this->desc, TRUE, array( ), NULL, NULL, NULL, 'ms_dDescription' ) );
			$form->add( new \IPS\Helpers\Form\Text( 'ms_dFawesome', $this->icon, TRUE, array( ), NULL, NULL, NULL, 'ms_dFawesome' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'ms_dPrice', $this->price, TRUE, array( ), NULL, NULL, NULL, 'ms_dPrice' ) );
		
			if ( $this->item_id == 1 or $this->item_id == 2 or $this->item_id == 3 or $this->item_id == 5 or $this->item_id == 16 or $this->item_id == 17)
			{
				$form->add( new \IPS\Helpers\Form\Number( 'ms_dMinRand', $this->minRand, TRUE, array( ), NULL, NULL, NULL, 'ms_dMinRand' ) );
				$form->add( new \IPS\Helpers\Form\Number( 'ms_dMaxRand', $this->maxRand, TRUE, array( ), NULL, NULL, NULL, 'ms_dMaxRand' ) );
			}
		
			if ( $this->item_id == 10 )
			{
				$form->add( new \IPS\Helpers\Form\YesNo( 'ms_enable_increase', $this->extra_field, TRUE, array( 'togglesOn' => array( 'ms_increase_amount') ), NULL, NULL, NULL, 'ms_enable_increase' ) );
				$form->add( new \IPS\Helpers\Form\Number( 'ms_increase_amount', $this->maxRand, FALSE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_points' ), 'ms_increase_amount' ) );
			}
		
			if ( $this->item_id == 11 )
			{
				$form->add( new \IPS\Helpers\Form\Number( 'ms_pin_time_days', $this->extra_field, TRUE, array( 'max' => 31, 'min' => 1 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_pin_time_days' ) );
			}
		
			if ( $this->item_id == 12 )
			{
				$form->add( new \IPS\Helpers\Form\Number( 'ms_feature_time_days', $this->extra_field, TRUE, array( 'max' => 31, 'min' => 1 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_feature_time_days' ) );
			}
		
			if ( $this->item_id == 13 or $this->item_id == 14 or $this->item_id == 15 )
			{
				$form->add( new \IPS\Helpers\Form\Select( 'ms_reward_user_group', $this->minRand, TRUE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ) ) );
		        $form->add( new \IPS\Helpers\Form\Select( 'ms_select_reward_dmy', $this->maxRand, TRUE, array( 
				'options' => array(
					0  => 'Days',
					1  => 'Months',
					2  => 'Years'),
				 'toggles' => array(
					0 => array( 'ms_upgrade_time_days' ),
					1 => array( 'ms_upgrade_time_months' ),
					2 => array( 'ms_upgrade_time_years' ),
				) ), NULL, NULL, NULL, 'ms_select_reward_dmy'));	
	    		$form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_days', $this->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_days' ), 'ms_upgrade_time_days' ) );
			    $form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_months', $this->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_months' ), 'ms_upgrade_time_months' ) );
			    $form->add( new \IPS\Helpers\Form\Number( 'ms_upgrade_time_years', $this->extra_field, TRUE, array( 'min' => 0 ), NULL, NULL, \IPS\Member::loggedIn()->language()->addToStack( 'ms_years' ), 'ms_upgrade_time_years' ) );
			}
			
			if ( $this->item_id == 21 )
			{
				$form->add( new \IPS\Helpers\Form\Number( 'ms_multipleguess', $this->minRand, TRUE, array( ), NULL, NULL, NULL, 'ms_multipleguess' ) );
				$form->add( new \IPS\Helpers\Form\Number( 'ms_guessnumbermaxamount', $this->maxRand, TRUE, array( ), NULL, NULL, NULL, 'ms_guessnumbermaxamount' ) );
			}
		
	        $form->add( new \IPS\Helpers\Form\Number( 'ms_stock', $this->instock, TRUE, array( 'unlimited' => -1 ), NULL, NULL, NULL, 'ms_stock' ) );
	
			if ( $values = $form->values() )
	        {
				/* Save standard values */
		        $this->icon = $values['ms_dFawesome'];
				$this->name = $values['ms_dName'];
				$this->desc = $values['ms_dDescription'];
				$this->price = $values['ms_dPrice'];
				$this->instock = $values['ms_stock'];
			
				/* Save random items values */
				if ( $this->item_id == 1 or $this->item_id == 2 or $this->item_id == 3 or $this->item_id == 5 or $this->item_id == 16 or $this->item_id == 17 )
				{
					$this->minRand = $values['ms_dMinRand'];
					$this->maxRand = $values['ms_dMaxRand'];
				}
			
				/* Save rpsls increase values */
				if ( $this->item_id == 10 )
				{
					$this->extra_field = $values['ms_enable_increase'];
					$this->maxRand = $values['ms_increase_amount'];
				}
			
				/* Save pinned values */
				if ( $this->item_id == 11 )
				{
					$this->extra_field = $values['ms_pin_time_days'];
				}
			
				/* Save featured values */
				if ( $this->item_id == 12 )
				{
					$this->extra_field = $values['ms_feature_time_days'];
				}
			
				/* Save member upgrade values */
				if ( $this->item_id == 13 or $this->item_id == 14 or $this->item_id == 15 )
				{
					if ( $values['ms_select_reward_dmy'] == 0 )
					{
						$this->extra_field = $values['ms_upgrade_time_days'];
						$this->minRand = $values['ms_reward_user_group'];
						$this->maxRand = $values['ms_select_reward_dmy'];
					}
					elseif ( $values['ms_select_reward_dmy'] == 1 )
					{
						$this->extra_field = $values['ms_upgrade_time_months'];
						$this->minRand = $values['ms_reward_user_group'];
						$this->maxRand =  $values['ms_select_reward_dmy'];
					}
					elseif ( $values['ms_select_reward_dmy'] == 2 ) 
					{
						$this->extra_field = $values['ms_upgrade_time_years'];
						$this->minRand = $values['ms_reward_user_group'];
						$this->maxRand = $values['ms_select_reward_dmy'];
					}
				}
				
				if ( $this->item_id == 21 )
				{
					$this->minRand = $values['ms_multipleguess'];
					$this->maxRand = $values['ms_guessnumbermaxamount'];
				}
				$this->save();
			
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=membersshop&module=shop&controller=items&subnode='.$this->cat_id.'&do=permissions&id='.$this->id.'' ), 'saved' );
        	}
		}
		
	}
	
	public function getButtons( $url, $subnode = false )
    {
        $buttons = parent::getButtons( $url, $subnode );
		$buttons[ 'generate' ] = [
           	'icon'  => 'ravelry',
           	'title' => \IPS\Member::loggedIn()->language()->addToStack('ms_custom_purchase'),
           	'link'  => \IPS\Http\Url::internal( "app=membersshop&module=shop&controller=items&do=doCustom&item_id={$this->item_id}" ),
           	'data'  => [ ]
        ];
		$buttons[ 'stats' ] = [
           	'icon'  => 'eye',
           	'title' => \IPS\Member::loggedIn()->language()->addToStack('ms_purchasers'),
           	'link'  => \IPS\Http\Url::internal( "app=membersshop&module=shop&controller=items&do=purchasers&id={$this->_id}" ),
           	'data'  => [ 'ipsDialog' => '', 'ipsDialog-title' => \IPS\Member::loggedIn()->language()->addToStack( 'ms_purchasers' ) ]
        ];
        
        return $buttons;
    }
	
	public static function search( $column, $query, $order=NULL, $where=array() )
	{
		if ( $column === '_title' )
		{
			$column	= 'name';
		}

		if( $order == '_title' )
		{
			$order	= 'name';
		}

		return parent::search( $column, $query, $order, $where );
	} 
}